<?php

namespace ArtabanMarketplace\Model\Base;

use \Exception;
use \PDO;
use ArtabanMarketplace\Model\AmpSellerOrder as ChildAmpSellerOrder;
use ArtabanMarketplace\Model\AmpSellerOrderQuery as ChildAmpSellerOrderQuery;
use ArtabanMarketplace\Model\Map\AmpSellerOrderTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveQuery\ModelJoin;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;
use Thelia\Model\Customer;
use Thelia\Model\Order;

/**
 * Base class that represents a query for the 'amp_seller_order' table.
 *
 *
 *
 * @method     ChildAmpSellerOrderQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ChildAmpSellerOrderQuery orderByOrderId($order = Criteria::ASC) Order by the order_id column
 * @method     ChildAmpSellerOrderQuery orderByAmpSellerId($order = Criteria::ASC) Order by the amp_seller_id column
 * @method     ChildAmpSellerOrderQuery orderByCustomerId($order = Criteria::ASC) Order by the customer_id column
 * @method     ChildAmpSellerOrderQuery orderByOrderProductId($order = Criteria::ASC) Order by the order_product_id column
 * @method     ChildAmpSellerOrderQuery orderByAmpSellerOrderCounter($order = Criteria::ASC) Order by the amp_seller_order_counter column
 * @method     ChildAmpSellerOrderQuery orderBySellerOrderRef($order = Criteria::ASC) Order by the seller_order_ref column
 * @method     ChildAmpSellerOrderQuery orderByDiscount($order = Criteria::ASC) Order by the discount column
 * @method     ChildAmpSellerOrderQuery orderByPostage($order = Criteria::ASC) Order by the postage column
 * @method     ChildAmpSellerOrderQuery orderByPostageTax($order = Criteria::ASC) Order by the postage_tax column
 * @method     ChildAmpSellerOrderQuery orderByStatusId($order = Criteria::ASC) Order by the status_id column
 * @method     ChildAmpSellerOrderQuery orderByCreatedAt($order = Criteria::ASC) Order by the created_at column
 * @method     ChildAmpSellerOrderQuery orderByUpdatedAt($order = Criteria::ASC) Order by the updated_at column
 * @method     ChildAmpSellerOrderQuery orderByVersion($order = Criteria::ASC) Order by the version column
 * @method     ChildAmpSellerOrderQuery orderByVersionCreatedAt($order = Criteria::ASC) Order by the version_created_at column
 * @method     ChildAmpSellerOrderQuery orderByVersionCreatedBy($order = Criteria::ASC) Order by the version_created_by column
 *
 * @method     ChildAmpSellerOrderQuery groupById() Group by the id column
 * @method     ChildAmpSellerOrderQuery groupByOrderId() Group by the order_id column
 * @method     ChildAmpSellerOrderQuery groupByAmpSellerId() Group by the amp_seller_id column
 * @method     ChildAmpSellerOrderQuery groupByCustomerId() Group by the customer_id column
 * @method     ChildAmpSellerOrderQuery groupByOrderProductId() Group by the order_product_id column
 * @method     ChildAmpSellerOrderQuery groupByAmpSellerOrderCounter() Group by the amp_seller_order_counter column
 * @method     ChildAmpSellerOrderQuery groupBySellerOrderRef() Group by the seller_order_ref column
 * @method     ChildAmpSellerOrderQuery groupByDiscount() Group by the discount column
 * @method     ChildAmpSellerOrderQuery groupByPostage() Group by the postage column
 * @method     ChildAmpSellerOrderQuery groupByPostageTax() Group by the postage_tax column
 * @method     ChildAmpSellerOrderQuery groupByStatusId() Group by the status_id column
 * @method     ChildAmpSellerOrderQuery groupByCreatedAt() Group by the created_at column
 * @method     ChildAmpSellerOrderQuery groupByUpdatedAt() Group by the updated_at column
 * @method     ChildAmpSellerOrderQuery groupByVersion() Group by the version column
 * @method     ChildAmpSellerOrderQuery groupByVersionCreatedAt() Group by the version_created_at column
 * @method     ChildAmpSellerOrderQuery groupByVersionCreatedBy() Group by the version_created_by column
 *
 * @method     ChildAmpSellerOrderQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildAmpSellerOrderQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildAmpSellerOrderQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildAmpSellerOrderQuery leftJoinCustomer($relationAlias = null) Adds a LEFT JOIN clause to the query using the Customer relation
 * @method     ChildAmpSellerOrderQuery rightJoinCustomer($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Customer relation
 * @method     ChildAmpSellerOrderQuery innerJoinCustomer($relationAlias = null) Adds a INNER JOIN clause to the query using the Customer relation
 *
 * @method     ChildAmpSellerOrderQuery leftJoinAmpSeller($relationAlias = null) Adds a LEFT JOIN clause to the query using the AmpSeller relation
 * @method     ChildAmpSellerOrderQuery rightJoinAmpSeller($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AmpSeller relation
 * @method     ChildAmpSellerOrderQuery innerJoinAmpSeller($relationAlias = null) Adds a INNER JOIN clause to the query using the AmpSeller relation
 *
 * @method     ChildAmpSellerOrderQuery leftJoinAmpSellerOrderStatus($relationAlias = null) Adds a LEFT JOIN clause to the query using the AmpSellerOrderStatus relation
 * @method     ChildAmpSellerOrderQuery rightJoinAmpSellerOrderStatus($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AmpSellerOrderStatus relation
 * @method     ChildAmpSellerOrderQuery innerJoinAmpSellerOrderStatus($relationAlias = null) Adds a INNER JOIN clause to the query using the AmpSellerOrderStatus relation
 *
 * @method     ChildAmpSellerOrderQuery leftJoinOrder($relationAlias = null) Adds a LEFT JOIN clause to the query using the Order relation
 * @method     ChildAmpSellerOrderQuery rightJoinOrder($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Order relation
 * @method     ChildAmpSellerOrderQuery innerJoinOrder($relationAlias = null) Adds a INNER JOIN clause to the query using the Order relation
 *
 * @method     ChildAmpSellerOrderQuery leftJoinAmpSellerOrderDeliveryReference($relationAlias = null) Adds a LEFT JOIN clause to the query using the AmpSellerOrderDeliveryReference relation
 * @method     ChildAmpSellerOrderQuery rightJoinAmpSellerOrderDeliveryReference($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AmpSellerOrderDeliveryReference relation
 * @method     ChildAmpSellerOrderQuery innerJoinAmpSellerOrderDeliveryReference($relationAlias = null) Adds a INNER JOIN clause to the query using the AmpSellerOrderDeliveryReference relation
 *
 * @method     ChildAmpSellerOrderQuery leftJoinAmpSellerOrderVersion($relationAlias = null) Adds a LEFT JOIN clause to the query using the AmpSellerOrderVersion relation
 * @method     ChildAmpSellerOrderQuery rightJoinAmpSellerOrderVersion($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AmpSellerOrderVersion relation
 * @method     ChildAmpSellerOrderQuery innerJoinAmpSellerOrderVersion($relationAlias = null) Adds a INNER JOIN clause to the query using the AmpSellerOrderVersion relation
 *
 * @method     ChildAmpSellerOrder findOne(ConnectionInterface $con = null) Return the first ChildAmpSellerOrder matching the query
 * @method     ChildAmpSellerOrder findOneOrCreate(ConnectionInterface $con = null) Return the first ChildAmpSellerOrder matching the query, or a new ChildAmpSellerOrder object populated from the query conditions when no match is found
 *
 * @method     ChildAmpSellerOrder findOneById(int $id) Return the first ChildAmpSellerOrder filtered by the id column
 * @method     ChildAmpSellerOrder findOneByOrderId(int $order_id) Return the first ChildAmpSellerOrder filtered by the order_id column
 * @method     ChildAmpSellerOrder findOneByAmpSellerId(int $amp_seller_id) Return the first ChildAmpSellerOrder filtered by the amp_seller_id column
 * @method     ChildAmpSellerOrder findOneByCustomerId(int $customer_id) Return the first ChildAmpSellerOrder filtered by the customer_id column
 * @method     ChildAmpSellerOrder findOneByOrderProductId(string $order_product_id) Return the first ChildAmpSellerOrder filtered by the order_product_id column
 * @method     ChildAmpSellerOrder findOneByAmpSellerOrderCounter(int $amp_seller_order_counter) Return the first ChildAmpSellerOrder filtered by the amp_seller_order_counter column
 * @method     ChildAmpSellerOrder findOneBySellerOrderRef(string $seller_order_ref) Return the first ChildAmpSellerOrder filtered by the seller_order_ref column
 * @method     ChildAmpSellerOrder findOneByDiscount(string $discount) Return the first ChildAmpSellerOrder filtered by the discount column
 * @method     ChildAmpSellerOrder findOneByPostage(string $postage) Return the first ChildAmpSellerOrder filtered by the postage column
 * @method     ChildAmpSellerOrder findOneByPostageTax(string $postage_tax) Return the first ChildAmpSellerOrder filtered by the postage_tax column
 * @method     ChildAmpSellerOrder findOneByStatusId(int $status_id) Return the first ChildAmpSellerOrder filtered by the status_id column
 * @method     ChildAmpSellerOrder findOneByCreatedAt(string $created_at) Return the first ChildAmpSellerOrder filtered by the created_at column
 * @method     ChildAmpSellerOrder findOneByUpdatedAt(string $updated_at) Return the first ChildAmpSellerOrder filtered by the updated_at column
 * @method     ChildAmpSellerOrder findOneByVersion(int $version) Return the first ChildAmpSellerOrder filtered by the version column
 * @method     ChildAmpSellerOrder findOneByVersionCreatedAt(string $version_created_at) Return the first ChildAmpSellerOrder filtered by the version_created_at column
 * @method     ChildAmpSellerOrder findOneByVersionCreatedBy(string $version_created_by) Return the first ChildAmpSellerOrder filtered by the version_created_by column
 *
 * @method     array findById(int $id) Return ChildAmpSellerOrder objects filtered by the id column
 * @method     array findByOrderId(int $order_id) Return ChildAmpSellerOrder objects filtered by the order_id column
 * @method     array findByAmpSellerId(int $amp_seller_id) Return ChildAmpSellerOrder objects filtered by the amp_seller_id column
 * @method     array findByCustomerId(int $customer_id) Return ChildAmpSellerOrder objects filtered by the customer_id column
 * @method     array findByOrderProductId(string $order_product_id) Return ChildAmpSellerOrder objects filtered by the order_product_id column
 * @method     array findByAmpSellerOrderCounter(int $amp_seller_order_counter) Return ChildAmpSellerOrder objects filtered by the amp_seller_order_counter column
 * @method     array findBySellerOrderRef(string $seller_order_ref) Return ChildAmpSellerOrder objects filtered by the seller_order_ref column
 * @method     array findByDiscount(string $discount) Return ChildAmpSellerOrder objects filtered by the discount column
 * @method     array findByPostage(string $postage) Return ChildAmpSellerOrder objects filtered by the postage column
 * @method     array findByPostageTax(string $postage_tax) Return ChildAmpSellerOrder objects filtered by the postage_tax column
 * @method     array findByStatusId(int $status_id) Return ChildAmpSellerOrder objects filtered by the status_id column
 * @method     array findByCreatedAt(string $created_at) Return ChildAmpSellerOrder objects filtered by the created_at column
 * @method     array findByUpdatedAt(string $updated_at) Return ChildAmpSellerOrder objects filtered by the updated_at column
 * @method     array findByVersion(int $version) Return ChildAmpSellerOrder objects filtered by the version column
 * @method     array findByVersionCreatedAt(string $version_created_at) Return ChildAmpSellerOrder objects filtered by the version_created_at column
 * @method     array findByVersionCreatedBy(string $version_created_by) Return ChildAmpSellerOrder objects filtered by the version_created_by column
 *
 */
abstract class AmpSellerOrderQuery extends ModelCriteria
{

    // versionable behavior

    /**
     * Whether the versioning is enabled
     */
    static $isVersioningEnabled = true;

    /**
     * Initializes internal state of \ArtabanMarketplace\Model\Base\AmpSellerOrderQuery object.
     *
     * @param     string $dbName The database name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'thelia', $modelName = '\\ArtabanMarketplace\\Model\\AmpSellerOrder', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildAmpSellerOrderQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param     Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildAmpSellerOrderQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof \ArtabanMarketplace\Model\AmpSellerOrderQuery) {
            return $criteria;
        }
        $query = new \ArtabanMarketplace\Model\AmpSellerOrderQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildAmpSellerOrder|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AmpSellerOrderTableMap::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(AmpSellerOrderTableMap::DATABASE_NAME);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return   ChildAmpSellerOrder A model object, or null if the key is not found
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT ID, ORDER_ID, AMP_SELLER_ID, CUSTOMER_ID, ORDER_PRODUCT_ID, AMP_SELLER_ORDER_COUNTER, SELLER_ORDER_REF, DISCOUNT, POSTAGE, POSTAGE_TAX, STATUS_ID, CREATED_AT, UPDATED_AT, VERSION, VERSION_CREATED_AT, VERSION_CREATED_BY FROM amp_seller_order WHERE ID = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            $obj = new ChildAmpSellerOrder();
            $obj->hydrate($row);
            AmpSellerOrderTableMap::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return ChildAmpSellerOrder|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     ConnectionInterface $con an optional connection object
     *
     * @return ObjectCollection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AmpSellerOrderTableMap::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AmpSellerOrderTableMap::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::ID, $id, $comparison);
    }

    /**
     * Filter the query on the order_id column
     *
     * Example usage:
     * <code>
     * $query->filterByOrderId(1234); // WHERE order_id = 1234
     * $query->filterByOrderId(array(12, 34)); // WHERE order_id IN (12, 34)
     * $query->filterByOrderId(array('min' => 12)); // WHERE order_id > 12
     * </code>
     *
     * @see       filterByOrder()
     *
     * @param     mixed $orderId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByOrderId($orderId = null, $comparison = null)
    {
        if (is_array($orderId)) {
            $useMinMax = false;
            if (isset($orderId['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::ORDER_ID, $orderId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($orderId['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::ORDER_ID, $orderId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::ORDER_ID, $orderId, $comparison);
    }

    /**
     * Filter the query on the amp_seller_id column
     *
     * Example usage:
     * <code>
     * $query->filterByAmpSellerId(1234); // WHERE amp_seller_id = 1234
     * $query->filterByAmpSellerId(array(12, 34)); // WHERE amp_seller_id IN (12, 34)
     * $query->filterByAmpSellerId(array('min' => 12)); // WHERE amp_seller_id > 12
     * </code>
     *
     * @see       filterByAmpSeller()
     *
     * @param     mixed $ampSellerId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByAmpSellerId($ampSellerId = null, $comparison = null)
    {
        if (is_array($ampSellerId)) {
            $useMinMax = false;
            if (isset($ampSellerId['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::AMP_SELLER_ID, $ampSellerId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($ampSellerId['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::AMP_SELLER_ID, $ampSellerId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::AMP_SELLER_ID, $ampSellerId, $comparison);
    }

    /**
     * Filter the query on the customer_id column
     *
     * Example usage:
     * <code>
     * $query->filterByCustomerId(1234); // WHERE customer_id = 1234
     * $query->filterByCustomerId(array(12, 34)); // WHERE customer_id IN (12, 34)
     * $query->filterByCustomerId(array('min' => 12)); // WHERE customer_id > 12
     * </code>
     *
     * @see       filterByCustomer()
     *
     * @param     mixed $customerId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByCustomerId($customerId = null, $comparison = null)
    {
        if (is_array($customerId)) {
            $useMinMax = false;
            if (isset($customerId['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::CUSTOMER_ID, $customerId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($customerId['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::CUSTOMER_ID, $customerId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::CUSTOMER_ID, $customerId, $comparison);
    }

    /**
     * Filter the query on the order_product_id column
     *
     * Example usage:
     * <code>
     * $query->filterByOrderProductId('fooValue');   // WHERE order_product_id = 'fooValue'
     * $query->filterByOrderProductId('%fooValue%'); // WHERE order_product_id LIKE '%fooValue%'
     * </code>
     *
     * @param     string $orderProductId The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByOrderProductId($orderProductId = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($orderProductId)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $orderProductId)) {
                $orderProductId = str_replace('*', '%', $orderProductId);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::ORDER_PRODUCT_ID, $orderProductId, $comparison);
    }

    /**
     * Filter the query on the amp_seller_order_counter column
     *
     * Example usage:
     * <code>
     * $query->filterByAmpSellerOrderCounter(1234); // WHERE amp_seller_order_counter = 1234
     * $query->filterByAmpSellerOrderCounter(array(12, 34)); // WHERE amp_seller_order_counter IN (12, 34)
     * $query->filterByAmpSellerOrderCounter(array('min' => 12)); // WHERE amp_seller_order_counter > 12
     * </code>
     *
     * @param     mixed $ampSellerOrderCounter The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByAmpSellerOrderCounter($ampSellerOrderCounter = null, $comparison = null)
    {
        if (is_array($ampSellerOrderCounter)) {
            $useMinMax = false;
            if (isset($ampSellerOrderCounter['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::AMP_SELLER_ORDER_COUNTER, $ampSellerOrderCounter['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($ampSellerOrderCounter['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::AMP_SELLER_ORDER_COUNTER, $ampSellerOrderCounter['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::AMP_SELLER_ORDER_COUNTER, $ampSellerOrderCounter, $comparison);
    }

    /**
     * Filter the query on the seller_order_ref column
     *
     * Example usage:
     * <code>
     * $query->filterBySellerOrderRef('fooValue');   // WHERE seller_order_ref = 'fooValue'
     * $query->filterBySellerOrderRef('%fooValue%'); // WHERE seller_order_ref LIKE '%fooValue%'
     * </code>
     *
     * @param     string $sellerOrderRef The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterBySellerOrderRef($sellerOrderRef = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($sellerOrderRef)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $sellerOrderRef)) {
                $sellerOrderRef = str_replace('*', '%', $sellerOrderRef);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::SELLER_ORDER_REF, $sellerOrderRef, $comparison);
    }

    /**
     * Filter the query on the discount column
     *
     * Example usage:
     * <code>
     * $query->filterByDiscount(1234); // WHERE discount = 1234
     * $query->filterByDiscount(array(12, 34)); // WHERE discount IN (12, 34)
     * $query->filterByDiscount(array('min' => 12)); // WHERE discount > 12
     * </code>
     *
     * @param     mixed $discount The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByDiscount($discount = null, $comparison = null)
    {
        if (is_array($discount)) {
            $useMinMax = false;
            if (isset($discount['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::DISCOUNT, $discount['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($discount['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::DISCOUNT, $discount['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::DISCOUNT, $discount, $comparison);
    }

    /**
     * Filter the query on the postage column
     *
     * Example usage:
     * <code>
     * $query->filterByPostage(1234); // WHERE postage = 1234
     * $query->filterByPostage(array(12, 34)); // WHERE postage IN (12, 34)
     * $query->filterByPostage(array('min' => 12)); // WHERE postage > 12
     * </code>
     *
     * @param     mixed $postage The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByPostage($postage = null, $comparison = null)
    {
        if (is_array($postage)) {
            $useMinMax = false;
            if (isset($postage['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::POSTAGE, $postage['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($postage['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::POSTAGE, $postage['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::POSTAGE, $postage, $comparison);
    }

    /**
     * Filter the query on the postage_tax column
     *
     * Example usage:
     * <code>
     * $query->filterByPostageTax(1234); // WHERE postage_tax = 1234
     * $query->filterByPostageTax(array(12, 34)); // WHERE postage_tax IN (12, 34)
     * $query->filterByPostageTax(array('min' => 12)); // WHERE postage_tax > 12
     * </code>
     *
     * @param     mixed $postageTax The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByPostageTax($postageTax = null, $comparison = null)
    {
        if (is_array($postageTax)) {
            $useMinMax = false;
            if (isset($postageTax['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::POSTAGE_TAX, $postageTax['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($postageTax['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::POSTAGE_TAX, $postageTax['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::POSTAGE_TAX, $postageTax, $comparison);
    }

    /**
     * Filter the query on the status_id column
     *
     * Example usage:
     * <code>
     * $query->filterByStatusId(1234); // WHERE status_id = 1234
     * $query->filterByStatusId(array(12, 34)); // WHERE status_id IN (12, 34)
     * $query->filterByStatusId(array('min' => 12)); // WHERE status_id > 12
     * </code>
     *
     * @see       filterByAmpSellerOrderStatus()
     *
     * @param     mixed $statusId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByStatusId($statusId = null, $comparison = null)
    {
        if (is_array($statusId)) {
            $useMinMax = false;
            if (isset($statusId['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::STATUS_ID, $statusId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($statusId['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::STATUS_ID, $statusId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::STATUS_ID, $statusId, $comparison);
    }

    /**
     * Filter the query on the created_at column
     *
     * Example usage:
     * <code>
     * $query->filterByCreatedAt('2011-03-14'); // WHERE created_at = '2011-03-14'
     * $query->filterByCreatedAt('now'); // WHERE created_at = '2011-03-14'
     * $query->filterByCreatedAt(array('max' => 'yesterday')); // WHERE created_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $createdAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByCreatedAt($createdAt = null, $comparison = null)
    {
        if (is_array($createdAt)) {
            $useMinMax = false;
            if (isset($createdAt['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::CREATED_AT, $createdAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($createdAt['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::CREATED_AT, $createdAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::CREATED_AT, $createdAt, $comparison);
    }

    /**
     * Filter the query on the updated_at column
     *
     * Example usage:
     * <code>
     * $query->filterByUpdatedAt('2011-03-14'); // WHERE updated_at = '2011-03-14'
     * $query->filterByUpdatedAt('now'); // WHERE updated_at = '2011-03-14'
     * $query->filterByUpdatedAt(array('max' => 'yesterday')); // WHERE updated_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $updatedAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByUpdatedAt($updatedAt = null, $comparison = null)
    {
        if (is_array($updatedAt)) {
            $useMinMax = false;
            if (isset($updatedAt['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::UPDATED_AT, $updatedAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($updatedAt['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::UPDATED_AT, $updatedAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::UPDATED_AT, $updatedAt, $comparison);
    }

    /**
     * Filter the query on the version column
     *
     * Example usage:
     * <code>
     * $query->filterByVersion(1234); // WHERE version = 1234
     * $query->filterByVersion(array(12, 34)); // WHERE version IN (12, 34)
     * $query->filterByVersion(array('min' => 12)); // WHERE version > 12
     * </code>
     *
     * @param     mixed $version The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByVersion($version = null, $comparison = null)
    {
        if (is_array($version)) {
            $useMinMax = false;
            if (isset($version['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::VERSION, $version['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($version['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::VERSION, $version['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::VERSION, $version, $comparison);
    }

    /**
     * Filter the query on the version_created_at column
     *
     * Example usage:
     * <code>
     * $query->filterByVersionCreatedAt('2011-03-14'); // WHERE version_created_at = '2011-03-14'
     * $query->filterByVersionCreatedAt('now'); // WHERE version_created_at = '2011-03-14'
     * $query->filterByVersionCreatedAt(array('max' => 'yesterday')); // WHERE version_created_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $versionCreatedAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByVersionCreatedAt($versionCreatedAt = null, $comparison = null)
    {
        if (is_array($versionCreatedAt)) {
            $useMinMax = false;
            if (isset($versionCreatedAt['min'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::VERSION_CREATED_AT, $versionCreatedAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($versionCreatedAt['max'])) {
                $this->addUsingAlias(AmpSellerOrderTableMap::VERSION_CREATED_AT, $versionCreatedAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::VERSION_CREATED_AT, $versionCreatedAt, $comparison);
    }

    /**
     * Filter the query on the version_created_by column
     *
     * Example usage:
     * <code>
     * $query->filterByVersionCreatedBy('fooValue');   // WHERE version_created_by = 'fooValue'
     * $query->filterByVersionCreatedBy('%fooValue%'); // WHERE version_created_by LIKE '%fooValue%'
     * </code>
     *
     * @param     string $versionCreatedBy The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByVersionCreatedBy($versionCreatedBy = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($versionCreatedBy)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $versionCreatedBy)) {
                $versionCreatedBy = str_replace('*', '%', $versionCreatedBy);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderTableMap::VERSION_CREATED_BY, $versionCreatedBy, $comparison);
    }

    /**
     * Filter the query by a related \Thelia\Model\Customer object
     *
     * @param \Thelia\Model\Customer|ObjectCollection $customer The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByCustomer($customer, $comparison = null)
    {
        if ($customer instanceof \Thelia\Model\Customer) {
            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::CUSTOMER_ID, $customer->getId(), $comparison);
        } elseif ($customer instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::CUSTOMER_ID, $customer->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByCustomer() only accepts arguments of type \Thelia\Model\Customer or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Customer relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function joinCustomer($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Customer');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Customer');
        }

        return $this;
    }

    /**
     * Use the Customer relation Customer object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \Thelia\Model\CustomerQuery A secondary query class using the current class as primary query
     */
    public function useCustomerQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinCustomer($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Customer', '\Thelia\Model\CustomerQuery');
    }

    /**
     * Filter the query by a related \ArtabanMarketplace\Model\AmpSeller object
     *
     * @param \ArtabanMarketplace\Model\AmpSeller|ObjectCollection $ampSeller The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByAmpSeller($ampSeller, $comparison = null)
    {
        if ($ampSeller instanceof \ArtabanMarketplace\Model\AmpSeller) {
            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::AMP_SELLER_ID, $ampSeller->getId(), $comparison);
        } elseif ($ampSeller instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::AMP_SELLER_ID, $ampSeller->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAmpSeller() only accepts arguments of type \ArtabanMarketplace\Model\AmpSeller or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AmpSeller relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function joinAmpSeller($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AmpSeller');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AmpSeller');
        }

        return $this;
    }

    /**
     * Use the AmpSeller relation AmpSeller object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerQuery A secondary query class using the current class as primary query
     */
    public function useAmpSellerQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmpSeller($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AmpSeller', '\ArtabanMarketplace\Model\AmpSellerQuery');
    }

    /**
     * Filter the query by a related \ArtabanMarketplace\Model\AmpSellerOrderStatus object
     *
     * @param \ArtabanMarketplace\Model\AmpSellerOrderStatus|ObjectCollection $ampSellerOrderStatus The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByAmpSellerOrderStatus($ampSellerOrderStatus, $comparison = null)
    {
        if ($ampSellerOrderStatus instanceof \ArtabanMarketplace\Model\AmpSellerOrderStatus) {
            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::STATUS_ID, $ampSellerOrderStatus->getId(), $comparison);
        } elseif ($ampSellerOrderStatus instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::STATUS_ID, $ampSellerOrderStatus->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAmpSellerOrderStatus() only accepts arguments of type \ArtabanMarketplace\Model\AmpSellerOrderStatus or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AmpSellerOrderStatus relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function joinAmpSellerOrderStatus($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AmpSellerOrderStatus');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AmpSellerOrderStatus');
        }

        return $this;
    }

    /**
     * Use the AmpSellerOrderStatus relation AmpSellerOrderStatus object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderStatusQuery A secondary query class using the current class as primary query
     */
    public function useAmpSellerOrderStatusQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmpSellerOrderStatus($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AmpSellerOrderStatus', '\ArtabanMarketplace\Model\AmpSellerOrderStatusQuery');
    }

    /**
     * Filter the query by a related \Thelia\Model\Order object
     *
     * @param \Thelia\Model\Order|ObjectCollection $order The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByOrder($order, $comparison = null)
    {
        if ($order instanceof \Thelia\Model\Order) {
            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::ORDER_ID, $order->getId(), $comparison);
        } elseif ($order instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::ORDER_ID, $order->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByOrder() only accepts arguments of type \Thelia\Model\Order or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Order relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function joinOrder($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Order');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Order');
        }

        return $this;
    }

    /**
     * Use the Order relation Order object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \Thelia\Model\OrderQuery A secondary query class using the current class as primary query
     */
    public function useOrderQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinOrder($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Order', '\Thelia\Model\OrderQuery');
    }

    /**
     * Filter the query by a related \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReference object
     *
     * @param \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReference|ObjectCollection $ampSellerOrderDeliveryReference  the related object to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByAmpSellerOrderDeliveryReference($ampSellerOrderDeliveryReference, $comparison = null)
    {
        if ($ampSellerOrderDeliveryReference instanceof \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReference) {
            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::ID, $ampSellerOrderDeliveryReference->getOrderSellerId(), $comparison);
        } elseif ($ampSellerOrderDeliveryReference instanceof ObjectCollection) {
            return $this
                ->useAmpSellerOrderDeliveryReferenceQuery()
                ->filterByPrimaryKeys($ampSellerOrderDeliveryReference->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByAmpSellerOrderDeliveryReference() only accepts arguments of type \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReference or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AmpSellerOrderDeliveryReference relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function joinAmpSellerOrderDeliveryReference($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AmpSellerOrderDeliveryReference');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AmpSellerOrderDeliveryReference');
        }

        return $this;
    }

    /**
     * Use the AmpSellerOrderDeliveryReference relation AmpSellerOrderDeliveryReference object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceQuery A secondary query class using the current class as primary query
     */
    public function useAmpSellerOrderDeliveryReferenceQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmpSellerOrderDeliveryReference($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AmpSellerOrderDeliveryReference', '\ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceQuery');
    }

    /**
     * Filter the query by a related \ArtabanMarketplace\Model\AmpSellerOrderVersion object
     *
     * @param \ArtabanMarketplace\Model\AmpSellerOrderVersion|ObjectCollection $ampSellerOrderVersion  the related object to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function filterByAmpSellerOrderVersion($ampSellerOrderVersion, $comparison = null)
    {
        if ($ampSellerOrderVersion instanceof \ArtabanMarketplace\Model\AmpSellerOrderVersion) {
            return $this
                ->addUsingAlias(AmpSellerOrderTableMap::ID, $ampSellerOrderVersion->getId(), $comparison);
        } elseif ($ampSellerOrderVersion instanceof ObjectCollection) {
            return $this
                ->useAmpSellerOrderVersionQuery()
                ->filterByPrimaryKeys($ampSellerOrderVersion->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByAmpSellerOrderVersion() only accepts arguments of type \ArtabanMarketplace\Model\AmpSellerOrderVersion or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AmpSellerOrderVersion relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function joinAmpSellerOrderVersion($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AmpSellerOrderVersion');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AmpSellerOrderVersion');
        }

        return $this;
    }

    /**
     * Use the AmpSellerOrderVersion relation AmpSellerOrderVersion object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersionQuery A secondary query class using the current class as primary query
     */
    public function useAmpSellerOrderVersionQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmpSellerOrderVersion($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AmpSellerOrderVersion', '\ArtabanMarketplace\Model\AmpSellerOrderVersionQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   ChildAmpSellerOrder $ampSellerOrder Object to remove from the list of results
     *
     * @return ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function prune($ampSellerOrder = null)
    {
        if ($ampSellerOrder) {
            $this->addUsingAlias(AmpSellerOrderTableMap::ID, $ampSellerOrder->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the amp_seller_order table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderTableMap::DATABASE_NAME);
        }
        $affectedRows = 0; // initialize var to track total num of affected rows
        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            AmpSellerOrderTableMap::clearInstancePool();
            AmpSellerOrderTableMap::clearRelatedInstancePool();

            $con->commit();
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        return $affectedRows;
    }

    /**
     * Performs a DELETE on the database, given a ChildAmpSellerOrder or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or ChildAmpSellerOrder object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
     public function delete(ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(AmpSellerOrderTableMap::DATABASE_NAME);

        $affectedRows = 0; // initialize var to track total num of affected rows

        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();


        AmpSellerOrderTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            AmpSellerOrderTableMap::clearRelatedInstancePool();
            $con->commit();

            return $affectedRows;
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }
    }

    // timestampable behavior

    /**
     * Filter by the latest updated
     *
     * @param      int $nbDays Maximum age of the latest update in days
     *
     * @return     ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function recentlyUpdated($nbDays = 7)
    {
        return $this->addUsingAlias(AmpSellerOrderTableMap::UPDATED_AT, time() - $nbDays * 24 * 60 * 60, Criteria::GREATER_EQUAL);
    }

    /**
     * Filter by the latest created
     *
     * @param      int $nbDays Maximum age of in days
     *
     * @return     ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function recentlyCreated($nbDays = 7)
    {
        return $this->addUsingAlias(AmpSellerOrderTableMap::CREATED_AT, time() - $nbDays * 24 * 60 * 60, Criteria::GREATER_EQUAL);
    }

    /**
     * Order by update date desc
     *
     * @return     ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function lastUpdatedFirst()
    {
        return $this->addDescendingOrderByColumn(AmpSellerOrderTableMap::UPDATED_AT);
    }

    /**
     * Order by update date asc
     *
     * @return     ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function firstUpdatedFirst()
    {
        return $this->addAscendingOrderByColumn(AmpSellerOrderTableMap::UPDATED_AT);
    }

    /**
     * Order by create date desc
     *
     * @return     ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function lastCreatedFirst()
    {
        return $this->addDescendingOrderByColumn(AmpSellerOrderTableMap::CREATED_AT);
    }

    /**
     * Order by create date asc
     *
     * @return     ChildAmpSellerOrderQuery The current query, for fluid interface
     */
    public function firstCreatedFirst()
    {
        return $this->addAscendingOrderByColumn(AmpSellerOrderTableMap::CREATED_AT);
    }

    // versionable behavior

    /**
     * Checks whether versioning is enabled
     *
     * @return boolean
     */
    static public function isVersioningEnabled()
    {
        return self::$isVersioningEnabled;
    }

    /**
     * Enables versioning
     */
    static public function enableVersioning()
    {
        self::$isVersioningEnabled = true;
    }

    /**
     * Disables versioning
     */
    static public function disableVersioning()
    {
        self::$isVersioningEnabled = false;
    }

} // AmpSellerOrderQuery
